#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/types.h>

#define STDIN 0
#define STDOUT 1
#define READ 0
#define WRITE 1


typedef struct
{
 int error;
 int positiveACK;
 int negativeACK;
 int content;
 int pid_p;
 int pid_c;
 int exit;
} MESSAGE;


void main()
{
 int masterfd[2];
 int slavefd[2][2];
 int pid, pid_c, pid_p, status;
 int masterProcess, slaveProcess;

 printf("====START: Simulation====\n");
 cout<<"Start with pid = " << getpid()<<endl;
 if(pid > 0)
 {
  pipe(masterfd);
  close(masterfd[WRITE]);
  for(masterProcess=0; masterProcess<2; masterProcess++)
  {
   pipe(slavefd[masterProcess]);
   pid = fork();
   close(slavefd[masterProcess][READ]);
  }
  MESSAGE masterMSG;
  for(int i=2; i>0; i--)
  {
   read(masterfd[READ], &masterMSG, sizeof(masterMSG)); 
   cout<<"Parent ("<<getpid()<<")";
   cout<<" read from ("<<masterMSG.pid_c<<") content ";
   cout<<masterMSG.content<<endl;
   write(slavefd[i][WRITE], &masterMSG, sizeof(masterMSG));
  } 
  close(masterfd[READ]);
 }
 else if(pid == 0)
 {
  cout<<"I am in child"<<endl;
  close(masterfd[READ]);
  close(slavefd[masterProcess][READ]);
  for(slaveProcess=0; slaveProcess<2; slaveProcess++)
  {
   if(masterProcess != slaveProcess)
   {
    close(slavefd[slaveProcess][READ]);
    close(slavefd[slaveProcess][WRITE]);
   }
  }
  MESSAGE childMSG;
  childMSG.pid_p = getppid();
  if(slaveProcess == 0)
  {
   childMSG.pid_c = getpid();
   childMSG.content = 10;
   childMSG.positiveACK = 0;
   childMSG.negativeACK = 0;
   childMSG.error = 0;
   write(masterfd[WRITE], &childMSG, sizeof(childMSG));
   wait(&status);
   read(slavefd[slaveProcess][READ], &childMSG, sizeof(childMSG));
   cout<<"Child ("<<getpid()<<") receives from "<<getppid();  
   cout<<" acknowledgement of " << childMSG.positiveACK << endl;
   close(slavefd[slaveProcess][READ]);
   close(slavefd[slaveProcess][WRITE]);
   cout<<"Child ("<<getpid()<<") is exiting"<<endl;
   exit(0);
  }
  else
  {
   // 2nd child
   childMSG.pid_c = getpid();
   read(slavefd[slaveProcess][READ], &childMSG, sizeof(childMSG));
   cout<<"Child ("<<getpid()<<") receives from "<<getppid();
   cout<<" content of " << childMSG.content << endl; 
   childMSG.positiveACK = 1;
   write(masterfd[WRITE],&childMSG, sizeof(childMSG));
   close(slavefd[slaveProcess][READ]);
   close(slavefd[slaveProcess][WRITE]);
   cout<<"Child ("<<getpid()<<") is exiting"<<endl;
   exit(0);
  } 
 }
 else
 {
  cout<<"ERROR: Big Time!"<<endl;
  exit(0);
 }
}
