#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/types.h>

#define STDIN 0
#define STDOUT 1
#define READ 0
#define WRITE 1


typedef struct
{
 int error;
 int positiveACK;
 int negativeACK;
 int content;
 int pid_p;
 int pid_c;
 int exit;
} MESSAGE;

void respond(MESSAGE&,int);
void ACK(MESSAGE);

void main()
{
 int fd[2];
 int pid=0, pid_c=0, pid_p=0;
 printf("====START: Simulation====\n");

 for(int i=0; i<2; i++)
 {
  if(pipe(fd)<0)
   cerr<<"ERROR: pipe creation.\n";
  pid = fork();
  if(pid<0)
   cerr<<"ERROR: fork creation. \n";

  if(pid == 0) // child
  {
   MESSAGE msgChild;
   pid_c = getpid();
   cout<<"CHILD : "<<pid_c;
   read(fd[READ],&msgChild,sizeof(msgChild));
   cout<<" receive msg from "<<msgChild.pid_p;
   cout<<" | content:"<<msgChild.content<<endl; 
   respond(msgChild,pid_c);
   write(fd[WRITE],&msgChild,sizeof(msgChild));
   close(fd[READ]);
   close(fd[WRITE]);
   exit(0);
  }
  else // parent
  {
   MESSAGE msg;
   msg.content = 10;
   pid_p = getpid();
   msg.pid_p = pid_p;
   msg.error = 0;
   cout<<"PARENT: "<<pid_p; 
   write(fd[WRITE],&msg,sizeof(msg)); 
   cout<<" sends MSG to child already"<<endl;
   read(fd[READ], &msg, sizeof(msg));
   ACK(msg);
  }
 } // end of for-loop

 close(fd[READ]);
 close(fd[WRITE]);
 printf("====END: Simulation====\n");

}

void respond(MESSAGE& msg, int pid_c)
{
 if(msg.error == 0)
 {
     msg.positiveACK = 1;
     msg.negativeACK = 0;
     msg.pid_c = pid_c;
 }
 else
 { 
     msg.negativeACK = 1;
     msg.positiveACK = 0;
     msg.pid_c = pid_c;
 }
}

void ACK(MESSAGE msg)
{
 if(msg.positiveACK == 0)
  cout<<"-> Parent "<<msg.pid_p<<
  " receives from "<<msg.pid_c<<" negativeACK"<<endl;
 else
  cout<<"-> Parent "<<msg.pid_p<<
  " receives from "<<msg.pid_c<<" positiveACK"<<endl;
}
