#include "Filter.h" 

int detectError(char* filename);

void main()
{
 int found = detectError("testIT.html");
 cout<<"found: " << found <<endl;
}

/**
 * detectError(): To detect HTTP 1.0 error code through
 *                a given ASCII file. If it found the code,  
 *                it will return the corresponding code number
 *                of error code. Basically anything other than
 *                code = 200 [OK] would be consider as an error
 *                if it does not find any error code in the page,
 *                it will return -1; It will only concern of the
 *                first occurance of the following line: 
 *                   HTTP/1.1 200 OK
 *                from HTTP Reply
 * @param  char* filename 
 * @return int error code
 */
int detectError(char* filename)
{
 Filter filter;
 filter.setConstraint("200"); //OK
 filter.setConstraint("201"); //Created
 filter.setConstraint("202"); //Accepted
 filter.setConstraint("204"); //No Content
 filter.setConstraint("301"); //Moved Permanently
 filter.setConstraint("302"); //Moved Temporarily
 filter.setConstraint("304"); //Not Modified
 filter.setConstraint("400"); //Bad Request
 filter.setConstraint("401"); //Unauthorized
 filter.setConstraint("403"); //Forbidden
 filter.setConstraint("404"); //Not Found
 filter.setConstraint("500"); //Internal Server Error
 filter.setConstraint("501"); //Not Implemented
 filter.setConstraint("502"); //Bad Gateway
 filter.setConstraint("503"); //Service Unavailabe

 ifstream file;
 char buffer[LENGTH+1];
 file.open(filename,ios::in);
 if(!file.is_open())
 {
  cerr<<"Error in opening file: "<<filename<<endl;
  exit(0);
 }
 char *token;
 bool found = false;
 int getit = 0;
 while(!file.eof())
 {
  file.getline(buffer,LENGTH+1);
  char *strpos = buffer; 
  while((token=strsep(&strpos," ")) != NULL)
    if((strcmp(token,"HTTP/1.1") == 0) ||
       (strcmp(token,"HTTP/1.0") == 0))
    { 
      found = true;
      break; 
    }
  if(found)
  {
   while((token=strsep(&strpos," ")) != NULL)
   {
     getit = filter.search(token); 
     if(getit >= 0)
       return atoi(filter.showConstraint(getit)); 
   }
  }
 }
 return -1; // not found
}
