#include <unistd.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

#define READ 0
#define WRITE 1

typedef struct
{
 int recv;
 int resp;
 int cid;
}MESSAGE;

void main()
{
  int masterfd[2];
  int slave[4][2];
  int status;
  bool finish;

  if(pipe(masterfd)<0)
  {
    cerr<<"Error pipe"<<endl;
    exit(0);
  } 
  close(masterfd[WRITE]);

  MESSAGE pmsg;
  pmsg.cid = getpid();
  pmsg.resp = 0;

  int identification,pid;

  for(identification=0; identification<4; identification++)
  {
   if(pipe(slave[identification]) < 0)
   {
    cerr<<"error in pipe"<<endl;
    exit(0); 
   }
   pid = fork();
   if(pid < 0)
   {
    cerr<<"error in fork"<<endl;
    exit(0);
   }
   if(pid == 0)
     break;
   close(slave[identification][READ]);
   close(masterfd[WRITE]);
   pmsg.recv = (identification+1) * 5;
   write(slave[identification][WRITE],&pmsg,sizeof(pmsg));
   cout<<"Parent wrote to child ("<<identification<<"): ";
   cout<<pmsg.recv<<endl;
  }

  if(identification == 4)
  {
   for(int i=0; i<4; i++)
   {
    pmsg.recv = (i+1) * 5;
    write(slave[i][WRITE],&pmsg,sizeof(pmsg));
    cout<<"Parent wrote to child ("<<i;
    cout<<"): "<<pmsg.recv<<endl;
   }
   cout<<"Parent finishes"<<endl;
  }

  if(pid == 0) // child process
  {
   cout<<"child: "<<identification<<" ";
   close(masterfd[READ]);
   close(slave[identification][WRITE]);

   for(int j=0; j<4; j++)
   {
    if(identification != j)
    {
     close(slave[j][READ]);
     close(slave[j][WRITE]);
    }
   }
   MESSAGE cmsg;
   cmsg.cid = 0;
   cmsg.recv= 0;
   cmsg.resp= 0;
   read(slave[identification][READ],&cmsg,sizeof(cmsg));
   cout<<"[pid= "<<getpid()<<"] receives ";
   cout<<cmsg.recv<<" from ";
   cout<<cmsg.cid<<endl; 
   close(slave[identification][READ]);
   close(slave[identification][WRITE]);
   exit(0);
  } 
}
